#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>

#include "defines.h"
#include "lcd_select.h"
#include "main.h"
u32 tmp1[6];
u8 tmp1_zl;
v u8 abfr=0,ir_adr;
u16 ir_cmd,res_ir;
u8 x;
u8 fb_yellow_mnu;	
u8 fb_color_mnu;	
//================= sensor =============================
// 
//______________
//    ______
//     ____
// 1     2     3
//DAT   GND   VCC
//=======================================================

#define fb_green 5

//=======================================================
#define ir_sens_port D
#define ir_sens_pin  2
#define ir_sens_int_port 2

#define ir_sens_value_register PIN(ir_sens_port)
#if ir_sens_int_port==0
#define ir_sens_vect 	PCINT0_vect
#endif
#if ir_sens_int_port==1
#define ir_sens_vect 	PCINT1_vect
#endif
#if ir_sens_int_port==2
#define ir_sens_vect 	PCINT2_vect
#endif
#if ir_sens_int_port==3
#define ir_sens_vect 	PCINT3_vect
#endif
#define PCMSK(x)    GLUE(PCMSK, x)
#define PCIE(x)    	GLUE(PCIE, x)


v u16 ir_tmp[100];
v u8 ir_n;




void ir_sens_init(void){
DDR(ir_sens_port)&=~(1<< ir_sens_pin);
PORT(ir_sens_port)|=((1<< ir_sens_pin));
PCICR |= (1 << PCIE(ir_sens_int_port));//PCIntControlRegister
PCMSK(ir_sens_int_port) |= (1<< ir_sens_pin);
sei();
}
//--------------------------------------------------

ISR(ir_sens_vect){

if(! down_timer1 || ir_start==1){

	if(!ir_start){
		TIM3_CNT=0;
		down_timer1=100;
//		led1_on;
		ir_start=1;
		ir_n=0;
		fb_color_mnu=1;
	}else{
		ir_tmp[ir_n++]=TIM3_CNT;
		TIM3_CNT=0;
		down_timer1=25;
	}
}



//led1_tog;
}





void sub_ir_end(void){
		fb_color_mnu=0;
	u8 i,f_ir;
	u16 result;
	
		u8 oldBit;
	u16 rc5code;//50
	oldBit=1;
	u8 zl=0;
	u8 endwhile=1,n=1;
	u8         j;
	u16 wertx,colx;

	
	down_timer1=0;
//	led1_off;
	ir_start=0;
/*	
	lcd_goto(2,1);
	for(i=0;i<5;i++){
	lcd_int4(ir_tmp[i]);
	}
lcd_goto(3,1);
	for(i=5;i<10;i++){
	lcd_int4(ir_tmp[i]);
	}
lcd_goto(4,1);
	for(i=45;i<50;i++){
	lcd_int4(ir_tmp[i]);
	}
*/


u16 ir_div=((u16)(ir_tmp[0]*10))/ir_tmp[1];
//lcd_goto(1,10);
//lcd_int4(ir_div);
//		lcd_int(ir_div);
//		lcd_write(" ");


//rc5 -code
if(ir_div>7 && ir_div<13)//rc5
{




//f_ir=ir_tmp[1]/10;
//	ir_tmp[0]=1;
	//IR-Signale aus ir_tmp[] in Bitfolge rc5code umrechnen
ir_cmd=0;		
ir_adr=0;		
		
		f_ir=ir_tmp[0]*3/2;
//lcd_goto(2,1);
		  for(i=5;i<11;i=i+1) {
		  if(ir_tmp[i]/f_ir)ir_adr++;
		  ir_adr=ir_adr<<1;
//		  lcd_int(ir_tmp[i]/f_ir);
}
//lcd_goto(3,1);
		  for(i=11;i<22;i=i+1) {
		  if(ir_tmp[i]/f_ir)ir_cmd++;
		  ir_cmd=ir_cmd<<1;
//		  lcd_int(ir_tmp[i]/f_ir);
}		
		
		
//lg(3,1);lcd_hx(ir_adr);lcd_hx(ir_cmd);
//lg(4,1);lcd_hex16(rc5code);lw("  ");lcd_int4(ir_adr);lw("  ");lcd_int4(ir_cmd);
//lg(4,1);lcd_bitweise(rc5code);
}
//================================================


//NEC -code
 if(ir_div>17 && ir_div<25){//nec 95

			f_ir=ir_tmp[2]*3/2;
			ir_adr=0;ir_cmd=0;

//lcd_goto(3,1);
		  for(i=3;i<19;i=i+2) {
//		  lcd_int(ir_tmp[i]/f_ir);;
			ir_adr=(ir_adr<<1);
			if (!(ir_tmp[i]/f_ir))ir_adr++;}

//lcd_goto(3,11);
		  for(i=35;i<51;i=i+2) {
//		  lcd_int(ir_tmp[i]/f_ir);;
			  ir_cmd=(ir_cmd<<1);
			if (!(ir_tmp[i]/f_ir))ir_cmd++;}


	}


	
//TIM3->CR1&=~(1<<0);
//	TIM3->CNT=0;
/*		lcd_goto(2,1);
	for(i=4;i<24;i++){
		lcd_int(ir_tmp[i]/11);
	}
		lcd_write(" ");
		lcd_int(ir_tmp[1]);
		lcd_write(" ");
		lcd_int(ir_tmp[2]);
		lcd_write(" ");
*/	
/*		result=sub_ir_auswertung();
	lcd_goto(3,10);
	lcd_int(result>>8);
	lcd_write("/");
	lcd_int(result&0xff);
	lcd_write(" ");
*/

lcd_goto(1,13);
//lcd_int4(ir_div);
		lcd_hx(ir_adr);
		lcd_int(ir_cmd);lw(" ");
//		lcd_int(f_ir);


	//	
if(ir_adr==255)sub_ir_anwendung(ir_cmd);
ir_start=0;	
for(i=0;i<80;i++)ir_tmp[i]=0;

}



//*********************************************************




#if 0
int main(void)
{
	ir_signal();
    while(1)
    {
    }
}
#endif
